/* Kod för att visa kategorier och produkter i uppgift U7.
   Delvis lik koden i uppgift U2, fast här skriven på ett annat sätt. */
// --------------------------------------------------
// Skapa HTML-kod för "slides" med kategorierna och lägg på händelselyssnare.
function initCategories() {
    let wrapperElem = document.querySelector("#imgViewer .slideshow div");
    wrapperElem.innerHTML = ""; // Ta bort föregående "slides"
    for (let i = 0; i < categories.group.length; i++) { // Skapa nya "slides"
        let cat = categories.group[i]; // Objekt för aktuell kategori (definierad i data.js)
        let divElem = document.createElement("div"); // Element för en slide, som innehåller ...
        let imgElem = document.createElement("img"); // ... img-element för kategoribild ...
        let h4Elem = document.createElement("h4");   // ... och h4-element för kategorinamn
        divElem.className = "slide";
        imgElem.src = cat.img;
        imgElem.alt = "kategoribild";
        h4Elem.innerText = cat.name;
        divElem.appendChild(imgElem);
        divElem.appendChild(h4Elem);
        wrapperElem.appendChild(divElem);
        divElem.addEventListener("pointerdown", dragStart);
    }
} // Slut initCategories
// --------------------------------------------------
// Skapa HTML-kod för visning av produkterna i parametern jsonCode. Då funktionen anropas ska någon av produktvariablerna chocolate, caramel eller softcandy skickas med som parameter.
function showProducts(jsonCode) {
    document.querySelector("#products h3").innerText = jsonCode.category;
    let wrapperElem = document.querySelector("#products div");
    wrapperElem.innerHTML = "";
    for (let i = 0; i < jsonCode.products.length; i++) { // Gå igenom alla produkter
        let prod = jsonCode.products[i]; // Objekt för aktuell produkt
        let divElem = document.createElement("div");       // Element för produkten, som innehåller ...
        let imgElem = document.createElement("img");       // ... img-element för produktbild ...
        let h4Elem = document.createElement("h4");         // ... h4-element för produktnamn ...
        let pElem = document.createElement("p");           // ... p-element för pris ...
        let buttonElem = document.createElement("button"); // ... och knapp för att lägga i varukorg
        divElem.className = "product";
        imgElem.src = prod.img;
        imgElem.alt = "produkt";
        h4Elem.innerText = prod.name;
        pElem.innerText = "Pris: " + prod.price.toFixed(2) + " kr.";
        buttonElem.type = "button";
        buttonElem.className = "order";
        buttonElem.innerText = "Lägg i korg";
        divElem.appendChild(imgElem);
        divElem.appendChild(h4Elem);
        divElem.appendChild(pElem);
        divElem.appendChild(buttonElem);
        wrapperElem.appendChild(divElem);
        buttonElem.addEventListener("click", () => cart.addItem(prod.artnr) ); // Metod i ListObject
    }
} // Slut showProducts
// --------------------------------------------------
// Visa meddelande för produktkategori som ej finns.
function noProducts() {
    document.querySelector("#products h3").innerText = "";
    document.querySelector("#products div").innerText = "Tyvärr finns inte dessa varor i lager ännu.";
} // Slut noProducts
// --------------------------------------------------
