/* Uppgift U7 — startsidan */
/* I stort sett samma JavaScript-kod som i exempel F7-ex8, del a.
   Koden behöver modifieras och utökas enligt instruktioner i uppgiften. */
// --------------------------------------------------
// Globala variabler
let cart;               // Objekt för varukorgen
const minDrag = 100;    // Antal pixlar som man minst måste svepa för att bläddra
let wrapperElem;        // Element som omger alla "slides"
let slideWidth;         // Bredd på en "slide" (ändras då skärmstorleken ändras)
let currentIx;          // Index för den "slide" som visas
// --------------------------------------------------
// Initiering då webbsidan är inläst.
function init() {
    cart = new ListObject(null, "cart4738"); // Varukorgen
    wrapperElem = document.querySelector("#imgViewer .slideshow > div");
    initCategories(); // Visa kategorierna som slides
    currentIx = 0;
    showSlide(); // Visa första "slide"
    window.addEventListener("orientationchange", showSlide);
    window.addEventListener("resize", showSlide);
    document.addEventListener("keydown", checkKey);
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Förskjut wrapperElem (dvs alla slides) i x-led, för att visa aktuell slide. Förskjutningen blir åt vänster (negativt värde) i förhållande till ursprungsläget.
function showSlide() {
    slideWidth = wrapperElem.querySelector(".slide").offsetWidth; // Aktuell bredd på en slide
    wrapperElem.style.transitionDuration = "0.2s"; // Glidande övergång
    wrapperElem.style.transform = "translateX(" + (-currentIx * slideWidth) + "px)";
} // Slut showSlide
// --------------------------------------------------
// Påbörja en drag-operation, för att svepa slides åt vänster eller höger.
function dragStart(e) {
    e.preventDefault();
    if (!e.isPrimary) return; // Endast en pekare i detta program
    let dragElem = this;  // Den "slide" (div-element) som dras
    let startX = e.pageX; // Position där pekaren trycktes ner, för justering i dragMove
    wrapperElem.style.transitionDuration = "0s"; // Ingen transition medan man drar
    document.addEventListener("pointerup", dragEnd);
    document.addEventListener("pointercancel", dragEnd);
    dragElem.addEventListener("pointermove", dragMove);
    // ----------
    // Avsluta drag-operationen.
    function dragEnd(e) {
        e.preventDefault();
        if (!e.isPrimary) return;
        document.removeEventListener("pointerup", dragEnd);
        document.removeEventListener("pointercancel", dragEnd);
        dragElem.removeEventListener("pointermove", dragMove);
        if (e.pageX - startX > minDrag) { // Svep åt höger - skifta till föregående
            shiftToPrevious();
        }
        else if (e.pageX - startX < -minDrag) { // Svep åt vänster - skifta till nästa
            shiftToNext();
        }
        showSlide();
    } // Slut dragEnd
    // ----------
    // Elementet dras och förskjuts i x-led.
    function dragMove(e) {
        e.preventDefault();
        if (!e.isPrimary) return;
        let x = e.pageX - startX - currentIx * slideWidth;
        wrapperElem.style.transform = "translateX(" + x + "px)";
    } // Slut dragMove
    // ----------
} // Slut dragStart
// --------------------------------------------------
// Kontrollera tangenter och byt slide.
function checkKey(e) {
    switch (e.key) {
        case "ArrowLeft": // Skifta till föregående
            e.preventDefault();
            shiftToPrevious();
            showSlide();
            break;
        case "ArrowRight": // Skifta till nästa
            e.preventDefault();
            shiftToNext();
            showSlide();
            break;
    } // Slut switch
} // Slut checkKey
// --------------------------------------------------
// Skifta till föregående slide.
function shiftToPrevious() {
    if (currentIx > 0) {
        currentIx--;
    }
} // Slut shiftToPrevious
// --------------------------------------------------
// Skifta till nästa slide.
function shiftToNext() {
    let maxIx = wrapperElem.querySelectorAll(".slide").length - 1;  // Index för sista "slide"
    if (currentIx < maxIx) {
        currentIx++;
    }
} // Slut shiftToNext
// --------------------------------------------------
